#ifndef MAINWINDOW_H
#define MAINWINDOW_H

#include <QMainWindow>
#include <QGraphicsScene>
#include <iostream>
#include <thread>

extern "C"
{
    #include "UDP_API.h"
}

namespace Ui {
class MainWindow;
}

class MainWindow : public QMainWindow
{
    Q_OBJECT

public:
    explicit MainWindow(QWidget *parent = 0);
    ~MainWindow();

signals:
    void image_ready();

private slots:
    void on_pushButton_edit_nx_ny_clicked();
    void on_pushButton_edit_server_clicked();
    void on_pushButton_start_image_clicked();
    void on_pushButton_stop_image_clicked();
    void print_image();

private:
    Ui::MainWindow *ui;

    bool connected_to_server;
    int input_Nx;
    int input_Ny;
    int output_Nx;
    int output_Ny;
    int UDP_packet_size;

    QImage input_image;
    QImage displayed_image;
    QGraphicsScene *graph;

    // UDP client parameter
    SOCKET client_socket;
    SOCKADDR_IN client_sin;
    socklen_t sinlen;
    bool stream;
    uint8_t *data;

    void image_thread();
    std::thread image_construction_thread;
};

#endif // MAINWINDOW_H
